<?php

header("Content-type: application/x-javascript");
require_once("../../../wp-load.php");

# Globals
	$geourl = "http://www.flcounter.com/geoget.php";

# Remember user
	function _flcounter_remember_user()
	{
		# Ignore robots
		if (!preg_match("/Mozilla|Opera/i", $_SERVER['HTTP_USER_AGENT']) or preg_match("~Bot\s|Bot/|robot|Slurp/|yahoo~i", $_SERVER['HTTP_USER_AGENT'])) return;
		
		# Ignore existing users
		if (isset($_COOKIE["flcountermygeoloc"])) return;
		
		# Get user's ip
		function _flcounter_get_users_ip()
		{
				# try to define user's ip
				$_ip = $_SERVER['HTTP_X_FORWARDED_FOR'] ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['HTTP_CLIENT_IP'] ? $_SERVER['HTTP_CLIENT_IP'] : $_SERVER['REMOTE_ADDR'];
				
				# check if ip is a private one
				function _flcounter_is_private_addr($ip)
				{
					$lip = ip2long($ip); if ($lip < 0) return true;
					$arr = array('10.0.0.0'=>'10.255.255.255', '172.16.0.0'=>'172.31.255.255', '192.168.0.0'=>'192.168.255.255', '169.254.0.0'=>'169.254.255.255', '127.0.0.0'=>'127.255.255.255');
					foreach ($arr as $begin => $end) if ($lip >= ip2long($begin) and $lip <= ip2long($end)) return true;
					return false;
				};
				if (_flcounter_is_private_addr($_ip)) return $_ip;

				# check weather real ip address is allocated in get-param named 'ip'
				if (array_key_exists('ip', $_GET)) return $_GET['ip'];
				
				# redirect user to script which defines user's ip-address and redirects him here again
				global $geourl;
				header('HTTP/1.0 302 Found');
				header("Location: ${geourl}?return=".urlencode('http'.($_SERVER['HTTPS']?'s':'').'://'.$_SERVER['HTTP_HOST'].':'.$_SERVER['SERVER_PORT'].$_SERVER['REQUEST_URI']));
				exit;
		};
		$ip = _flcounter_get_users_ip();

		# Get user's country
		global $geourl;
		$country = @file_get_contents($geourl.'?ip='.urlencode($ip));
		//echo "flcounter.country = '".addslashes($country)."';\n";
		if (!$country or $country == 'ZZ' or !preg_match('~^\w{2}$~', $country)) return;
		
		global $wpdb;
		
		# Delete old visitors
		$opts = get_option('flcounter_opts');
		if ($opts['duration'] != 'all')
		{
			$intervals = array('24h' => '1 DAY', 'month' => '1 MONTH', 'year' => '1 YEAR');
			if (!$opts['duration'] or !array_key_exists($opts['duration'], $intervals)) $opts['duration'] = 'month';
			$wpdb->query("DELETE FROM `".$wpdb->prefix."flcountervisits` WHERE `timepoint` < NOW() - INTERVAL ".$intervals[$opts['duration']]);
		};
		
		# Remember user
		setcookie("flcountermygeoloc", $country, time()+24*3600);
		$wpdb->query($wpdb->prepare('INSERT INTO `'.$wpdb->prefix.'flcountervisits` (`country`, `timepoint`) values (%s, NOW())', $country));
	};
	_flcounter_remember_user();
	
# Data
	global $wpdb;
	$res = $wpdb->get_results("SELECT LOWER(`country`) as f, COUNT(*) as `c` FROM `".$wpdb->prefix."flcountervisits` WHERE `country` rlike '^[[:alpha:]]{2}$' GROUP BY `country` order by c desc", ARRAY_A);
	if (!$res) $res = array();
	echo "flcounter.data = ".json_encode($res).";\n";
	$_pageviews_count = 0; foreach ($res as $e) $_pageviews_count += $e['c'];
	echo "flcounter.pageviews = '".$_pageviews_count."';\n";
	echo "flcounter.countrycount = '".count($res)."';\n";
?>
